<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" label-width="100px" v-if="showSearch">
        <el-row>
          <!--          <el-col :span="10">-->
          <!--            <el-form-item label="udi">-->
          <!--              <el-input v-model="filterQuery.code" style="width: 90%" placeholder="请输入udi" clearable></el-input>-->
          <!--            </el-form-item>-->
          <!--          </el-col>-->

          <el-col :span="10">
            <el-form-item label="产品编码">
              <el-input v-model="filterQuery.nameCode" style="width: 90%" placeholder="请输入产品编码"
                        clearable></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="10">
            <el-form-item label="规格型号">
              <el-input v-model="filterQuery.ggxh" style="width: 90%" placeholder="请输入规格型号" clearable></el-input>
            </el-form-item>
          </el-col>

          <el-col :span="10">
            <el-form-item label="产品名称">
              <el-input v-model="filterQuery.cpmctymc" style="width: 90%" placeholder="请输入产品名称"
                        clearable></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmitFind">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="newDistributionForm()" :loading="loading">新增
          </el-button>
        </el-button-group>
      </div>

      <el-divider style="margin: 15px"></el-divider>

      <el-table v-loading="loading" :data="list" border highlight-current-row
                :default-expand-all="isExpandAll"
                :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
                style="width: 100%" row-key="id">
        <el-table-column label="序号" type="index" width="60"></el-table-column>
        <el-table-column label="上级编码" prop="parentCode"></el-table-column>
        <el-table-column label="产品编码" prop="nameCode"></el-table-column>
        <el-table-column label="产品名称" prop="cpmctymc"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh"></el-table-column>
        <el-table-column label="序列号" prop="serialNo"></el-table-column>
        <el-table-column label="创建时间" prop="createTime"></el-table-column>
        <el-table-column label="操作" width="120px">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native="newDistributionForm(scope.$index, scope.row)">编辑
            </el-button>
            <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="filterQuery.page"
        :limit.sync="filterQuery.limit"
        @pagination="handleCurrentChange"

      ></pagination>

      <el-dialog
        :title="formName"
        :visible.sync="newSpDistributionVisible"
        width="80%"
        v-if="newSpDistributionVisible"
        @close='closeDialog'
        :close-on-click-modal="false"
        :close-on-press-escape="false"
      >
        <ioCodeRelEdit
          :closeDialog="closeDialog"
          :idQuery="idQuery"
        ></ioCodeRelEdit>
      </el-dialog>


    </el-card>
  </div>
</template>
<script>
import {delIoCodeRel, getList} from "@/api/inout/ioCodeRel";
import ioCodeRelEdit from "@/views/inout/codeRel/ioCodeRelEdit"
import Treeselect from "@riophae/vue-treeselect";

export default {
  data() {
    return {
      showSearch: true,
      newSpDistributionVisible: false,
      filterQuery: {
        billAction: null,
        billNo: "",
        originType: null,
        thirdSysFk: "",
        page: 1,
        limit: 10,
        corpName: null,
        type: 1,
        editStatus: 1,
      },
      isExpandAll: true,
      idQuery: null,
      formName: null,
      loading: false,
      list: [],
      formData: null,
      total: 0,
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
    };
  },

  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        billNo: "",
        thirdSysFk: "",
        billFlag: null,
        billAction: null,
        startDate: null,
        endDate: null,
        page: 1,
        limit: 10,
        corpName: null,
        type: 1,
        editStatus: 1,
      };
      this.actDateRange = [];
      this.getList();
    },
    onSubmitFind() {
      this.filterQuery.page = 1;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    newDistributionForm(index, row) {
      if (this.$isNotBlank(row) && this.$isNotBlank(row.id)) {
        this.idQuery = row;
        this.formName = "编辑";
        this.newSpDistributionVisible = true;
      } else {
        this.formName = "新增";
        this.newSpDistributionVisible = true;
      }
    },
    closeDialog() {
      this.newSpDistributionVisible = false;
      this.getList();
      this.detailList = [];
    },
    deleteDialog(row) {
      delIoCodeRel({parentCode: row.parentCode})
        .then((response) => {
          if (response.code == 20000) {
            this.getList();
          } else {
            this.$message.error(response.message);
          }
        })
        .catch(() => {

        });
    },
    getList() {
      this.loading = true;
      getList(this.filterQuery)
        .then((response) => {
          if (response.code == 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    handleCurrentChange(val) {
      this.filterQuery.page = val.page;
      this.getList();
    },
  },
  components: {
    ioCodeRelEdit,
    Treeselect,
  },
  filters: {},
  mounted() {
  }
  ,
  created() {
    this.getList();
  }
  ,
}
;
</script>
<style scoped>
</style>

